import 'package:flutter/material.dart';

class TapTranslate extends StatefulWidget {
  final Widget child;
  final int milliseconds;

  TapTranslate({this.child, this.milliseconds});

  @override
  TapTranslateState createState() => TapTranslateState();
}

class TapTranslateState extends State<TapTranslate> {
  final notClicked = Matrix4.identity();
  final clicked = Matrix4.identity()..translate(0, -10, 0);

  bool clicking = false;

  @override
  Widget build(BuildContext context) {
    void setClick(bool click) {
      setState(() {
        clicking = click;
      });
    }

    return GestureDetector(
      onTapDown: (d) => setClick(true),
      onTapUp: (d) => setClick(false),
      child: AnimatedContainer(
        duration: Duration(milliseconds: widget.milliseconds),
        child: widget.child,
        transform: clicking ? clicked : notClicked,
      ),
    );
  }
}
